/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package modelo;

import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

/**
 *
 * @author willian
 */
@Entity
@Table(name = "Fornece")
@NamedQueries({
    @NamedQuery(name = "Fornece.findAll", query = "SELECT f FROM Fornece f"),
    @NamedQuery(name = "Fornece.findByFornecedorid", query = "SELECT f FROM Fornece f WHERE f.fornecePK.fornecedorid = :fornecedorid"),
    @NamedQuery(name = "Fornece.findByProdutoid", query = "SELECT f FROM Fornece f WHERE f.fornecePK.produtoid = :produtoid"),
    @NamedQuery(name = "Fornece.findByPreco", query = "SELECT f FROM Fornece f WHERE f.preco = :preco")})
public class Fornece implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected FornecePK fornecePK;
    @Column(name = "preco")
    private BigDecimal preco;
    @JoinColumn(name = "Produto_id", referencedColumnName = "id", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Produto produto;
    @JoinColumn(name = "Fornecedor_id", referencedColumnName = "id", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Fornecedor fornecedor;

    public Fornece() {
    }

    public Fornece(FornecePK fornecePK) {
        this.fornecePK = fornecePK;
    }

    public Fornece(int fornecedorid, int produtoid) {
        this.fornecePK = new FornecePK(fornecedorid, produtoid);
    }

    public FornecePK getFornecePK() {
        return fornecePK;
    }

    public void setFornecePK(FornecePK fornecePK) {
        this.fornecePK = fornecePK;
    }

    public BigDecimal getPreco() {
        return preco;
    }

    public void setPreco(BigDecimal preco) {
        this.preco = preco;
    }

    public Produto getProduto() {
        return produto;
    }

    public void setProduto(Produto produto) {
        this.produto = produto;
    }

    public Fornecedor getFornecedor() {
        return fornecedor;
    }

    public void setFornecedor(Fornecedor fornecedor) {
        this.fornecedor = fornecedor;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (fornecePK != null ? fornecePK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Fornece)) {
            return false;
        }
        Fornece other = (Fornece) object;
        if ((this.fornecePK == null && other.fornecePK != null) || (this.fornecePK != null && !this.fornecePK.equals(other.fornecePK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "modelo.Fornece[fornecePK=" + fornecePK + "]";
    }

}
