/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package modelo;

import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

/**
 *
 * @author willian
 */
@Entity
@Table(name = "Venda")
@NamedQueries({
    @NamedQuery(name = "Venda.findAll", query = "SELECT v FROM Venda v"),
    @NamedQuery(name = "Venda.findByPedidoVendaid", query = "SELECT v FROM Venda v WHERE v.vendaPK.pedidoVendaid = :pedidoVendaid"),
    @NamedQuery(name = "Venda.findByProdutoId", query = "SELECT v FROM Venda v WHERE v.vendaPK.produtoId = :produtoId"),
    @NamedQuery(name = "Venda.findByQuantidade", query = "SELECT v FROM Venda v WHERE v.quantidade = :quantidade"),
    @NamedQuery(name = "Venda.findByValorUnitario", query = "SELECT v FROM Venda v WHERE v.valorUnitario = :valorUnitario")})
public class Venda implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected VendaPK vendaPK;
    @Basic(optional = false)
    @Column(name = "quantidade")
    private BigDecimal quantidade;
    @Basic(optional = false)
    @Column(name = "valor_unitario")
    private BigDecimal valorUnitario;
    @JoinColumn(name = "produto_id", referencedColumnName = "id", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Produto produto;
    @JoinColumn(name = "pedidoVenda_id", referencedColumnName = "id", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private PedidoVenda pedidoVenda;

    public Venda() {
    }

    public Venda(VendaPK vendaPK) {
        this.vendaPK = vendaPK;
    }

    public Venda(VendaPK vendaPK, BigDecimal quantidade, BigDecimal valorUnitario) {
        this.vendaPK = vendaPK;
        this.quantidade = quantidade;
        this.valorUnitario = valorUnitario;
    }

    public Venda(int pedidoVendaid, int produtoId) {
        this.vendaPK = new VendaPK(pedidoVendaid, produtoId);
    }

    public VendaPK getVendaPK() {
        return vendaPK;
    }

    public void setVendaPK(VendaPK vendaPK) {
        this.vendaPK = vendaPK;
    }

    public BigDecimal getQuantidade() {
        return quantidade;
    }

    public void setQuantidade(BigDecimal quantidade) {
        this.quantidade = quantidade;
    }

    public BigDecimal getValorUnitario() {
        return valorUnitario;
    }

    public void setValorUnitario(BigDecimal valorUnitario) {
        this.valorUnitario = valorUnitario;
    }

    public Produto getProduto() {
        return produto;
    }

    public void setProduto(Produto produto) {
        this.produto = produto;
    }

    public PedidoVenda getPedidoVenda() {
        return pedidoVenda;
    }

    public void setPedidoVenda(PedidoVenda pedidoVenda) {
        this.pedidoVenda = pedidoVenda;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (vendaPK != null ? vendaPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {        
        if (!(object instanceof Venda)) {
            return false;
        }
        Venda other = (Venda) object;
        if ((this.vendaPK == null && other.vendaPK != null) || (this.vendaPK != null && !this.vendaPK.equals(other.vendaPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "modelo.Venda[vendaPK=" + vendaPK + "]";
    }

}
