/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package modelo.controle;

import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.EntityNotFoundException;
import modelo.Fornecedor;
import modelo.PedidoCompra;
import java.util.ArrayList;
import java.util.Collection;
import modelo.Fornece;
import modelo.controle.exceptions.IllegalOrphanException;
import modelo.controle.exceptions.NonexistentEntityException;
import modelo.controle.exceptions.PreexistingEntityException;

/**
 *
 * @author willian
 */
public class FornecedorJpaController {

    public FornecedorJpaController() {
        emf = Persistence.createEntityManagerFactory("EstoquePU");
    }
    private EntityManagerFactory emf = null;

    public EntityManager getEntityManager() {
        return emf.createEntityManager();
    }

    public void create(Fornecedor fornecedor) throws PreexistingEntityException, Exception {
        if (fornecedor.getPedidoCompraCollection() == null) {
            fornecedor.setPedidoCompraCollection(new ArrayList<PedidoCompra>());
        }
        if (fornecedor.getForneceCollection() == null) {
            fornecedor.setForneceCollection(new ArrayList<Fornece>());
        }
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Collection<PedidoCompra> attachedPedidoCompraCollection = new ArrayList<PedidoCompra>();
            for (PedidoCompra pedidoCompraCollectionPedidoCompraToAttach : fornecedor.getPedidoCompraCollection()) {
                pedidoCompraCollectionPedidoCompraToAttach = em.getReference(pedidoCompraCollectionPedidoCompraToAttach.getClass(), pedidoCompraCollectionPedidoCompraToAttach.getId());
                attachedPedidoCompraCollection.add(pedidoCompraCollectionPedidoCompraToAttach);
            }
            fornecedor.setPedidoCompraCollection(attachedPedidoCompraCollection);
            Collection<Fornece> attachedForneceCollection = new ArrayList<Fornece>();
            for (Fornece forneceCollectionForneceToAttach : fornecedor.getForneceCollection()) {
                forneceCollectionForneceToAttach = em.getReference(forneceCollectionForneceToAttach.getClass(), forneceCollectionForneceToAttach.getFornecePK());
                attachedForneceCollection.add(forneceCollectionForneceToAttach);
            }
            fornecedor.setForneceCollection(attachedForneceCollection);
            em.persist(fornecedor);
            for (PedidoCompra pedidoCompraCollectionPedidoCompra : fornecedor.getPedidoCompraCollection()) {
                Fornecedor oldFornecedorOfPedidoCompraCollectionPedidoCompra = pedidoCompraCollectionPedidoCompra.getFornecedor();
                pedidoCompraCollectionPedidoCompra.setFornecedor(fornecedor);
                pedidoCompraCollectionPedidoCompra = em.merge(pedidoCompraCollectionPedidoCompra);
                if (oldFornecedorOfPedidoCompraCollectionPedidoCompra != null) {
                    oldFornecedorOfPedidoCompraCollectionPedidoCompra.getPedidoCompraCollection().remove(pedidoCompraCollectionPedidoCompra);
                    oldFornecedorOfPedidoCompraCollectionPedidoCompra = em.merge(oldFornecedorOfPedidoCompraCollectionPedidoCompra);
                }
            }
            for (Fornece forneceCollectionFornece : fornecedor.getForneceCollection()) {
                Fornecedor oldFornecedorOfForneceCollectionFornece = forneceCollectionFornece.getFornecedor();
                forneceCollectionFornece.setFornecedor(fornecedor);
                forneceCollectionFornece = em.merge(forneceCollectionFornece);
                if (oldFornecedorOfForneceCollectionFornece != null) {
                    oldFornecedorOfForneceCollectionFornece.getForneceCollection().remove(forneceCollectionFornece);
                    oldFornecedorOfForneceCollectionFornece = em.merge(oldFornecedorOfForneceCollectionFornece);
                }
            }
            em.getTransaction().commit();
        } catch (Exception ex) {
            if (findFornecedor(fornecedor.getId()) != null) {
                throw new PreexistingEntityException("Fornecedor " + fornecedor + " already exists.", ex);
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void edit(Fornecedor fornecedor) throws IllegalOrphanException, NonexistentEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Fornecedor persistentFornecedor = em.find(Fornecedor.class, fornecedor.getId());
            Collection<PedidoCompra> pedidoCompraCollectionOld = persistentFornecedor.getPedidoCompraCollection();
            Collection<PedidoCompra> pedidoCompraCollectionNew = fornecedor.getPedidoCompraCollection();
            Collection<Fornece> forneceCollectionOld = persistentFornecedor.getForneceCollection();
            Collection<Fornece> forneceCollectionNew = fornecedor.getForneceCollection();
            List<String> illegalOrphanMessages = null;
            for (PedidoCompra pedidoCompraCollectionOldPedidoCompra : pedidoCompraCollectionOld) {
                if (!pedidoCompraCollectionNew.contains(pedidoCompraCollectionOldPedidoCompra)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain PedidoCompra " + pedidoCompraCollectionOldPedidoCompra + " since its fornecedor field is not nullable.");
                }
            }
            for (Fornece forneceCollectionOldFornece : forneceCollectionOld) {
                if (!forneceCollectionNew.contains(forneceCollectionOldFornece)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain Fornece " + forneceCollectionOldFornece + " since its fornecedor field is not nullable.");
                }
            }
            if (illegalOrphanMessages != null) {
                throw new IllegalOrphanException(illegalOrphanMessages);
            }
            Collection<PedidoCompra> attachedPedidoCompraCollectionNew = new ArrayList<PedidoCompra>();
            for (PedidoCompra pedidoCompraCollectionNewPedidoCompraToAttach : pedidoCompraCollectionNew) {
                pedidoCompraCollectionNewPedidoCompraToAttach = em.getReference(pedidoCompraCollectionNewPedidoCompraToAttach.getClass(), pedidoCompraCollectionNewPedidoCompraToAttach.getId());
                attachedPedidoCompraCollectionNew.add(pedidoCompraCollectionNewPedidoCompraToAttach);
            }
            pedidoCompraCollectionNew = attachedPedidoCompraCollectionNew;
            fornecedor.setPedidoCompraCollection(pedidoCompraCollectionNew);
            Collection<Fornece> attachedForneceCollectionNew = new ArrayList<Fornece>();
            for (Fornece forneceCollectionNewForneceToAttach : forneceCollectionNew) {
                forneceCollectionNewForneceToAttach = em.getReference(forneceCollectionNewForneceToAttach.getClass(), forneceCollectionNewForneceToAttach.getFornecePK());
                attachedForneceCollectionNew.add(forneceCollectionNewForneceToAttach);
            }
            forneceCollectionNew = attachedForneceCollectionNew;
            fornecedor.setForneceCollection(forneceCollectionNew);
            fornecedor = em.merge(fornecedor);
            for (PedidoCompra pedidoCompraCollectionNewPedidoCompra : pedidoCompraCollectionNew) {
                if (!pedidoCompraCollectionOld.contains(pedidoCompraCollectionNewPedidoCompra)) {
                    Fornecedor oldFornecedorOfPedidoCompraCollectionNewPedidoCompra = pedidoCompraCollectionNewPedidoCompra.getFornecedor();
                    pedidoCompraCollectionNewPedidoCompra.setFornecedor(fornecedor);
                    pedidoCompraCollectionNewPedidoCompra = em.merge(pedidoCompraCollectionNewPedidoCompra);
                    if (oldFornecedorOfPedidoCompraCollectionNewPedidoCompra != null && !oldFornecedorOfPedidoCompraCollectionNewPedidoCompra.equals(fornecedor)) {
                        oldFornecedorOfPedidoCompraCollectionNewPedidoCompra.getPedidoCompraCollection().remove(pedidoCompraCollectionNewPedidoCompra);
                        oldFornecedorOfPedidoCompraCollectionNewPedidoCompra = em.merge(oldFornecedorOfPedidoCompraCollectionNewPedidoCompra);
                    }
                }
            }
            for (Fornece forneceCollectionNewFornece : forneceCollectionNew) {
                if (!forneceCollectionOld.contains(forneceCollectionNewFornece)) {
                    Fornecedor oldFornecedorOfForneceCollectionNewFornece = forneceCollectionNewFornece.getFornecedor();
                    forneceCollectionNewFornece.setFornecedor(fornecedor);
                    forneceCollectionNewFornece = em.merge(forneceCollectionNewFornece);
                    if (oldFornecedorOfForneceCollectionNewFornece != null && !oldFornecedorOfForneceCollectionNewFornece.equals(fornecedor)) {
                        oldFornecedorOfForneceCollectionNewFornece.getForneceCollection().remove(forneceCollectionNewFornece);
                        oldFornecedorOfForneceCollectionNewFornece = em.merge(oldFornecedorOfForneceCollectionNewFornece);
                    }
                }
            }
            em.getTransaction().commit();
        } catch (Exception ex) {
            String msg = ex.getLocalizedMessage();
            if (msg == null || msg.length() == 0) {
                Integer id = fornecedor.getId();
                if (findFornecedor(id) == null) {
                    throw new NonexistentEntityException("The fornecedor with id " + id + " no longer exists.");
                }
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void destroy(Integer id) throws IllegalOrphanException, NonexistentEntityException {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Fornecedor fornecedor;
            try {
                fornecedor = em.getReference(Fornecedor.class, id);
                fornecedor.getId();
            } catch (EntityNotFoundException enfe) {
                throw new NonexistentEntityException("The fornecedor with id " + id + " no longer exists.", enfe);
            }
            List<String> illegalOrphanMessages = null;
            Collection<PedidoCompra> pedidoCompraCollectionOrphanCheck = fornecedor.getPedidoCompraCollection();
            for (PedidoCompra pedidoCompraCollectionOrphanCheckPedidoCompra : pedidoCompraCollectionOrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This Fornecedor (" + fornecedor + ") cannot be destroyed since the PedidoCompra " + pedidoCompraCollectionOrphanCheckPedidoCompra + " in its pedidoCompraCollection field has a non-nullable fornecedor field.");
            }
            Collection<Fornece> forneceCollectionOrphanCheck = fornecedor.getForneceCollection();
            for (Fornece forneceCollectionOrphanCheckFornece : forneceCollectionOrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This Fornecedor (" + fornecedor + ") cannot be destroyed since the Fornece " + forneceCollectionOrphanCheckFornece + " in its forneceCollection field has a non-nullable fornecedor field.");
            }
            if (illegalOrphanMessages != null) {
                throw new IllegalOrphanException(illegalOrphanMessages);
            }
            em.remove(fornecedor);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public List<Fornecedor> findFornecedorEntities() {
        return findFornecedorEntities(true, -1, -1);
    }

    public List<Fornecedor> findFornecedorEntities(int maxResults, int firstResult) {
        return findFornecedorEntities(false, maxResults, firstResult);
    }

    private List<Fornecedor> findFornecedorEntities(boolean all, int maxResults, int firstResult) {
        EntityManager em = getEntityManager();
        try {
            Query q = em.createQuery("select object(o) from Fornecedor as o");
            if (!all) {
                q.setMaxResults(maxResults);
                q.setFirstResult(firstResult);
            }
            return q.getResultList();
        } finally {
            em.close();
        }
    }

    public Fornecedor findFornecedor(Integer id) {
        EntityManager em = getEntityManager();
        try {
            return em.find(Fornecedor.class, id);
        } finally {
            em.close();
        }
    }

    public int getFornecedorCount() {
        EntityManager em = getEntityManager();
        try {
            Query q = em.createQuery("select count(o) from Fornecedor as o");
            return ((Long) q.getSingleResult()).intValue();
        } finally {
            em.close();
        }
    }

}
