/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package modelo.controle;

import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.EntityNotFoundException;
import modelo.Funcionario;
import modelo.Fornecedor;
import modelo.Compra;
import java.util.ArrayList;
import java.util.Collection;
import modelo.PedidoCompra;
import modelo.controle.exceptions.IllegalOrphanException;
import modelo.controle.exceptions.NonexistentEntityException;
import modelo.controle.exceptions.PreexistingEntityException;

/**
 *
 * @author willian
 */
public class PedidoCompraJpaController {

    public PedidoCompraJpaController() {
        emf = Persistence.createEntityManagerFactory("EstoquePU");
    }
    private EntityManagerFactory emf = null;

    public EntityManager getEntityManager() {
        return emf.createEntityManager();
    }

    public void create(PedidoCompra pedidoCompra) throws PreexistingEntityException, Exception {
        if (pedidoCompra.getCompraCollection() == null) {
            pedidoCompra.setCompraCollection(new ArrayList<Compra>());
        }
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Funcionario funcionario = pedidoCompra.getFuncionario();
            if (funcionario != null) {
                funcionario = em.getReference(funcionario.getClass(), funcionario.getId());
                pedidoCompra.setFuncionario(funcionario);
            }
            Fornecedor fornecedor = pedidoCompra.getFornecedor();
            if (fornecedor != null) {
                fornecedor = em.getReference(fornecedor.getClass(), fornecedor.getId());
                pedidoCompra.setFornecedor(fornecedor);
            }
            Collection<Compra> attachedCompraCollection = new ArrayList<Compra>();
            for (Compra compraCollectionCompraToAttach : pedidoCompra.getCompraCollection()) {
                compraCollectionCompraToAttach = em.getReference(compraCollectionCompraToAttach.getClass(), compraCollectionCompraToAttach.getCompraPK());
                attachedCompraCollection.add(compraCollectionCompraToAttach);
            }
            pedidoCompra.setCompraCollection(attachedCompraCollection);
            em.persist(pedidoCompra);
            if (funcionario != null) {
                funcionario.getPedidoCompraCollection().add(pedidoCompra);
                funcionario = em.merge(funcionario);
            }
            if (fornecedor != null) {
                fornecedor.getPedidoCompraCollection().add(pedidoCompra);
                fornecedor = em.merge(fornecedor);
            }
            for (Compra compraCollectionCompra : pedidoCompra.getCompraCollection()) {
                PedidoCompra oldPedidoCompraOfCompraCollectionCompra = compraCollectionCompra.getPedidoCompra();
                compraCollectionCompra.setPedidoCompra(pedidoCompra);
                compraCollectionCompra = em.merge(compraCollectionCompra);
                if (oldPedidoCompraOfCompraCollectionCompra != null) {
                    oldPedidoCompraOfCompraCollectionCompra.getCompraCollection().remove(compraCollectionCompra);
                    oldPedidoCompraOfCompraCollectionCompra = em.merge(oldPedidoCompraOfCompraCollectionCompra);
                }
            }
            em.getTransaction().commit();
        } catch (Exception ex) {
            if (findPedidoCompra(pedidoCompra.getId()) != null) {
                throw new PreexistingEntityException("PedidoCompra " + pedidoCompra + " already exists.", ex);
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void edit(PedidoCompra pedidoCompra) throws IllegalOrphanException, NonexistentEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            PedidoCompra persistentPedidoCompra = em.find(PedidoCompra.class, pedidoCompra.getId());
            Funcionario funcionarioOld = persistentPedidoCompra.getFuncionario();
            Funcionario funcionarioNew = pedidoCompra.getFuncionario();
            Fornecedor fornecedorOld = persistentPedidoCompra.getFornecedor();
            Fornecedor fornecedorNew = pedidoCompra.getFornecedor();
            Collection<Compra> compraCollectionOld = persistentPedidoCompra.getCompraCollection();
            Collection<Compra> compraCollectionNew = pedidoCompra.getCompraCollection();
            List<String> illegalOrphanMessages = null;
            for (Compra compraCollectionOldCompra : compraCollectionOld) {
                if (!compraCollectionNew.contains(compraCollectionOldCompra)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain Compra " + compraCollectionOldCompra + " since its pedidoCompra field is not nullable.");
                }
            }
            if (illegalOrphanMessages != null) {
                throw new IllegalOrphanException(illegalOrphanMessages);
            }
            if (funcionarioNew != null) {
                funcionarioNew = em.getReference(funcionarioNew.getClass(), funcionarioNew.getId());
                pedidoCompra.setFuncionario(funcionarioNew);
            }
            if (fornecedorNew != null) {
                fornecedorNew = em.getReference(fornecedorNew.getClass(), fornecedorNew.getId());
                pedidoCompra.setFornecedor(fornecedorNew);
            }
            Collection<Compra> attachedCompraCollectionNew = new ArrayList<Compra>();
            for (Compra compraCollectionNewCompraToAttach : compraCollectionNew) {
                compraCollectionNewCompraToAttach = em.getReference(compraCollectionNewCompraToAttach.getClass(), compraCollectionNewCompraToAttach.getCompraPK());
                attachedCompraCollectionNew.add(compraCollectionNewCompraToAttach);
            }
            compraCollectionNew = attachedCompraCollectionNew;
            pedidoCompra.setCompraCollection(compraCollectionNew);
            pedidoCompra = em.merge(pedidoCompra);
            if (funcionarioOld != null && !funcionarioOld.equals(funcionarioNew)) {
                funcionarioOld.getPedidoCompraCollection().remove(pedidoCompra);
                funcionarioOld = em.merge(funcionarioOld);
            }
            if (funcionarioNew != null && !funcionarioNew.equals(funcionarioOld)) {
                funcionarioNew.getPedidoCompraCollection().add(pedidoCompra);
                funcionarioNew = em.merge(funcionarioNew);
            }
            if (fornecedorOld != null && !fornecedorOld.equals(fornecedorNew)) {
                fornecedorOld.getPedidoCompraCollection().remove(pedidoCompra);
                fornecedorOld = em.merge(fornecedorOld);
            }
            if (fornecedorNew != null && !fornecedorNew.equals(fornecedorOld)) {
                fornecedorNew.getPedidoCompraCollection().add(pedidoCompra);
                fornecedorNew = em.merge(fornecedorNew);
            }
            for (Compra compraCollectionNewCompra : compraCollectionNew) {
                if (!compraCollectionOld.contains(compraCollectionNewCompra)) {
                    PedidoCompra oldPedidoCompraOfCompraCollectionNewCompra = compraCollectionNewCompra.getPedidoCompra();
                    compraCollectionNewCompra.setPedidoCompra(pedidoCompra);
                    compraCollectionNewCompra = em.merge(compraCollectionNewCompra);
                    if (oldPedidoCompraOfCompraCollectionNewCompra != null && !oldPedidoCompraOfCompraCollectionNewCompra.equals(pedidoCompra)) {
                        oldPedidoCompraOfCompraCollectionNewCompra.getCompraCollection().remove(compraCollectionNewCompra);
                        oldPedidoCompraOfCompraCollectionNewCompra = em.merge(oldPedidoCompraOfCompraCollectionNewCompra);
                    }
                }
            }
            em.getTransaction().commit();
        } catch (Exception ex) {
            String msg = ex.getLocalizedMessage();
            if (msg == null || msg.length() == 0) {
                Integer id = pedidoCompra.getId();
                if (findPedidoCompra(id) == null) {
                    throw new NonexistentEntityException("The pedidoCompra with id " + id + " no longer exists.");
                }
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void destroy(Integer id) throws IllegalOrphanException, NonexistentEntityException {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            PedidoCompra pedidoCompra;
            try {
                pedidoCompra = em.getReference(PedidoCompra.class, id);
                pedidoCompra.getId();
            } catch (EntityNotFoundException enfe) {
                throw new NonexistentEntityException("The pedidoCompra with id " + id + " no longer exists.", enfe);
            }
            List<String> illegalOrphanMessages = null;
            Collection<Compra> compraCollectionOrphanCheck = pedidoCompra.getCompraCollection();
            for (Compra compraCollectionOrphanCheckCompra : compraCollectionOrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This PedidoCompra (" + pedidoCompra + ") cannot be destroyed since the Compra " + compraCollectionOrphanCheckCompra + " in its compraCollection field has a non-nullable pedidoCompra field.");
            }
            if (illegalOrphanMessages != null) {
                throw new IllegalOrphanException(illegalOrphanMessages);
            }
            Funcionario funcionario = pedidoCompra.getFuncionario();
            if (funcionario != null) {
                funcionario.getPedidoCompraCollection().remove(pedidoCompra);
                funcionario = em.merge(funcionario);
            }
            Fornecedor fornecedor = pedidoCompra.getFornecedor();
            if (fornecedor != null) {
                fornecedor.getPedidoCompraCollection().remove(pedidoCompra);
                fornecedor = em.merge(fornecedor);
            }
            em.remove(pedidoCompra);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public List<PedidoCompra> findPedidoCompraEntities() {
        return findPedidoCompraEntities(true, -1, -1);
    }

    public List<PedidoCompra> findPedidoCompraEntities(int maxResults, int firstResult) {
        return findPedidoCompraEntities(false, maxResults, firstResult);
    }

    private List<PedidoCompra> findPedidoCompraEntities(boolean all, int maxResults, int firstResult) {
        EntityManager em = getEntityManager();
        try {
            Query q = em.createQuery("select object(o) from PedidoCompra as o");
            if (!all) {
                q.setMaxResults(maxResults);
                q.setFirstResult(firstResult);
            }
            return q.getResultList();
        } finally {
            em.close();
        }
    }

    public PedidoCompra findPedidoCompra(Integer id) {
        EntityManager em = getEntityManager();
        try {
            return em.find(PedidoCompra.class, id);
        } finally {
            em.close();
        }
    }

    public int getPedidoCompraCount() {
        EntityManager em = getEntityManager();
        try {
            Query q = em.createQuery("select count(o) from PedidoCompra as o");
            return ((Long) q.getSingleResult()).intValue();
        } finally {
            em.close();
        }
    }

}
